# __gnu_cxx::stdio_filebuf< _CharT, _Traits > Class Template Reference

Provides a layer of compatibility for C/POSIX. More...

Inheritance diagram for __gnu_cxx::stdio_filebuf< _CharT, _Traits >:

List of all members.

## Public Types

- typedef codecvt< char_type,
  char, __state_type > __codecvt_type
- typedef __basic_file< char > __file_type
- typedef basic_filebuf
  < char_type, traits_type > __filebuf_type
- typedef traits_type::state_type __state_type
- typedef basic_streambuf
  < char_type, traits_type > __streambuf_type
- typedef _CharT char_type
- typedef traits_type::int_type int_type
- typedef traits_type::off_type off_type
- typedef traits_type::pos_type pos_type
- typedef std::size_t size_t
- typedef _Traits traits_type

## Public Member Functions

- __filebuf_type * close ()
- int fd ()
- std::__c_file * file ()
- streamsize in_avail ()
- bool is_open () const throw ()
- __filebuf_type * open (const std::string &__s, ios_base::openmode __mode)
- __filebuf_type * open (const char *__s, ios_base::openmode __mode)
- int_type sbumpc ()
- int_type sgetc ()
- streamsize sgetn (char_type *__s, streamsize __n)
- int_type snextc ()
- int_type sputbackc (char_type __c)
- int_type sputc (char_type __c)
- streamsize sputn (const char_type *__s, streamsize __n)
- stdio_filebuf (std::__c_file *__f, std::ios_base::openmode __mode, size_t __size=static_cast< size_t >(BUFSIZ))
- stdio_filebuf (int __fd, std::ios_base::openmode __mode, size_t __size=static_cast< size_t >(BUFSIZ))
- stdio_filebuf ()
- void stossc ()
- int_type sungetc ()
- virtual ~stdio_filebuf ()

## Protected Member Functions

- void _M_allocate_internal_buffer ()
- bool _M_convert_to_external (char_type *, streamsize)
- void _M_create_pback ()
- void _M_destroy_internal_buffer () throw ()
- void _M_destroy_pback () throw ()
- pos_type _M_seek (off_type __off, ios_base::seekdir __way, __state_type __state)
- void _M_set_buffer (streamsize __off)
- bool _M_terminate_output ()
- void gbump (int __n)
- virtual void imbue (const locale &__loc)
- virtual int_type overflow (int_type __c=_Traits::eof())
- virtual int_type pbackfail (int_type __c=_Traits::eof())
- void pbump (int __n)
- virtual pos_type seekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
- virtual pos_type seekpos (pos_type __pos, ios_base::openmode __mode=ios_base::in|ios_base::out)
- virtual __streambuf_type * setbuf (char_type *__s, streamsize __n)
- void setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
- void setp (char_type *__pbeg, char_type *__pend)
- virtual streamsize showmanyc ()
- virtual int sync ()
- virtual int_type uflow ()
- virtual int_type underflow ()
- virtual streamsize xsgetn (char_type *__s, streamsize __n)
- virtual streamsize xsputn (const char_type *__s, streamsize __n)

- char_type * eback () const
- char_type * egptr () const
- char_type * gptr () const

- char_type * epptr () const
- char_type * pbase () const
- char_type * pptr () const

## Protected Attributes

- char_type * _M_buf
- bool _M_buf_allocated
- size_t _M_buf_size
- const __codecvt_type * _M_codecvt
- char * _M_ext_buf
- streamsize _M_ext_buf_size
- char * _M_ext_end
- const char * _M_ext_next
- __file_type _M_file
- __c_lock _M_lock
- ios_base::openmode _M_mode
- bool _M_reading
- __state_type _M_state_beg
- __state_type _M_state_cur
- __state_type _M_state_last
- bool _M_writing

- char_type _M_pback
- char_type * _M_pback_cur_save
- char_type * _M_pback_end_save
- bool _M_pback_init

## Friends

- __gnu_cxx::__enable_if
  < __is_char< _CharT2 >
  ::__value, _CharT2 * >::__type __copy_move_a2 (istreambuf_iterator< _CharT2 >, istreambuf_iterator< _CharT2 >, _CharT2 *)
- streamsize __copy_streambufs_eof (__streambuf_type *, __streambuf_type *, bool &)
- class basic_ios< char_type, traits_type >
- class basic_istream< char_type, traits_type >
- class basic_ostream< char_type, traits_type >
- __gnu_cxx::__enable_if
  < __is_char< _CharT2 >
  ::__value, istreambuf_iterator
  < _CharT2 > >::__type find (istreambuf_iterator< _CharT2 >, istreambuf_iterator< _CharT2 >, const _CharT2 &)
- basic_istream< _CharT2,
  _Traits2 > & getline (basic_istream< _CharT2, _Traits2 > &, basic_string< _CharT2, _Traits2, _Alloc > &, _CharT2)
- class ios_base
- class istreambuf_iterator< char_type, traits_type >
- basic_istream< _CharT2,
  _Traits2 > & operator>> (basic_istream< _CharT2, _Traits2 > &, basic_string< _CharT2, _Traits2, _Alloc > &)
- basic_istream< _CharT2,
  _Traits2 > & operator>> (basic_istream< _CharT2, _Traits2 > &, _CharT2 *)
- class ostreambuf_iterator< char_type, traits_type >

- locale getloc () const
- locale pubimbue (const locale &__loc)
- pos_type pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
- pos_type pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
- __streambuf_type * pubsetbuf (char_type *__s, streamsize __n)
- int pubsync ()
- locale _M_buf_locale
- char_type * _M_in_beg
- char_type * _M_in_cur
- char_type * _M_in_end
- char_type * _M_out_beg
- char_type * _M_out_cur
- char_type * _M_out_end

## Detailed Description

### template<typename _CharT, typename _Traits = std::char_traits<_CharT>>
class __gnu_cxx::stdio_filebuf< _CharT, _Traits >

Provides a layer of compatibility for C/POSIX.

This GNU extension provides extensions for working with standard C FILE*'s and POSIX file descriptors. It must be instantiated by the user with the type of character used in the file stream, e.g., stdio_filebuf<char>.

Definition at line 47 of file stdio_filebuf.h.

## Member Typedef Documentation

typedef basic_streambuf<char_type, traits_type> std::basic_filebuf< _CharT , _Traits >::__streambuf_type `[inherited]`

This is a non-standard type.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 77 of file fstream.

template<typename _CharT , typename _Traits = std::char_traits<_CharT>>

typedef _CharT __gnu_cxx::stdio_filebuf< _CharT, _Traits >::char_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_filebuf< _CharT, _Traits >.

Definition at line 51 of file stdio_filebuf.h.

template<typename _CharT , typename _Traits = std::char_traits<_CharT>>

typedef traits_type::int_type __gnu_cxx::stdio_filebuf< _CharT, _Traits >::int_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_filebuf< _CharT, _Traits >.

Definition at line 53 of file stdio_filebuf.h.

template<typename _CharT , typename _Traits = std::char_traits<_CharT>>

typedef traits_type::off_type __gnu_cxx::stdio_filebuf< _CharT, _Traits >::off_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_filebuf< _CharT, _Traits >.

Definition at line 55 of file stdio_filebuf.h.

template<typename _CharT , typename _Traits = std::char_traits<_CharT>>

typedef traits_type::pos_type __gnu_cxx::stdio_filebuf< _CharT, _Traits >::pos_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_filebuf< _CharT, _Traits >.

Definition at line 54 of file stdio_filebuf.h.

template<typename _CharT , typename _Traits = std::char_traits<_CharT>>

typedef _Traits __gnu_cxx::stdio_filebuf< _CharT, _Traits >::traits_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_filebuf< _CharT, _Traits >.

Definition at line 52 of file stdio_filebuf.h.

## Constructor & Destructor Documentation

template<typename _CharT , typename _Traits = std::char_traits<_CharT>>

__gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf | ( |  | ) | `[inline]`

deferred initialization

Definition at line 62 of file stdio_filebuf.h.

template<typename _CharT , typename _Traits >

__gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf | ( | int | __fd,
|  | std::ios_base::openmode | __mode,
|  | size_t | __size = `static_cast<size_t>(BUFSIZ)` |
| ) |  |  | `[inline]`

Parameters:

  | fd | An open file descriptor.
  | mode | Same meaning as in a standard filebuf.
  | size | Optimal or preferred size of internal buffer, in chars.

This constructor associates a file stream buffer with an open POSIX file descriptor. The file descriptor will be automatically closed when the stdio_filebuf is closed/destroyed.

Definition at line 124 of file stdio_filebuf.h.

References std::basic_filebuf< _CharT, _Traits >::_M_buf_size, std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_set_buffer(), and std::basic_filebuf< _CharT, _Traits >::is_open().

template<typename _CharT , typename _Traits >

__gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf | ( | std::__c_file * | __f,
|  | std::ios_base::openmode | __mode,
|  | size_t | __size = `static_cast<size_t>(BUFSIZ)` |
| ) |  |  | `[inline]`

Parameters:

  | f | An open `FILE*`.
  | mode | Same meaning as in a standard filebuf.
  | size | Optimal or preferred size of internal buffer, in chars. Defaults to system's `BUFSIZ`.

This constructor associates a file stream buffer with an open C `FILE*`. The `FILE*` will not be automatically closed when the stdio_filebuf is closed/destroyed.

Definition at line 140 of file stdio_filebuf.h.

References std::basic_filebuf< _CharT, _Traits >::_M_buf_size, std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_set_buffer(), and std::basic_filebuf< _CharT, _Traits >::is_open().

template<typename _CharT , typename _Traits >

__gnu_cxx::stdio_filebuf< _CharT, _Traits >::~stdio_filebuf | ( |  | ) | `[inline, virtual]`

Closes the external data stream if the file descriptor constructor was used.

Definition at line 119 of file stdio_filebuf.h.

## Member Function Documentation

void std::basic_filebuf< _CharT , _Traits >::_M_create_pback | ( |  | ) | `[inline, protected, inherited]`

Initializes pback buffers, and moves normal buffers to safety. Assumptions: _M_in_cur has already been moved back

Definition at line 172 of file fstream.

void std::basic_filebuf< _CharT , _Traits >::_M_destroy_pback | ( |  | ) | throw ()`[inline, protected, inherited]`

Deactivates pback buffer contents, and restores normal buffer. Assumptions: The pback buffer has only moved forward.

Definition at line 189 of file fstream.

void std::basic_filebuf< _CharT , _Traits >::_M_set_buffer | ( | streamsize | __off | ) | `[inline, protected, inherited]`

This function sets the pointers of the internal buffer, both get and put areas. Typically:

__off == egptr() - eback() upon underflow/uflow ('read' mode); __off == 0 upon overflow ('write' mode); __off == -1 upon open, setbuf, seekoff/pos ('uncommitted' mode).

NB: epptr() - pbase() == _M_buf_size - 1, since _M_buf_size reflects the actual allocated memory and the last cell is reserved for the overflow char of a full put area.

Definition at line 386 of file fstream.

Referenced by __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf().

__filebuf_type* std::basic_filebuf< _CharT , _Traits >::close | ( |  | ) | `[inherited]`

Closes the currently associated file.

Returns:
  `this` on success, NULL on failure

If no file is currently open, this function immediately fails.

If a "put buffer area" exists, `overflow(eof)` is called to flush all the characters. The file is then closed.

If any operations fail, this function also fails.

char_type* std::basic_streambuf< _CharT , _Traits >::eback | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 458 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

char_type* std::basic_streambuf< _CharT , _Traits >::egptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 464 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

char_type* std::basic_streambuf< _CharT , _Traits >::epptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 511 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow().

template<typename _CharT , typename _Traits = std::char_traits<_CharT>>

int __gnu_cxx::stdio_filebuf< _CharT, _Traits >::fd | ( |  | ) | `[inline]`

Returns:
  The underlying file descriptor.

Once associated with an external data stream, this function can be used to access the underlying POSIX file descriptor. Note that there is no way for the library to track what you do with the descriptor, so be careful.

Definition at line 105 of file stdio_filebuf.h.

template<typename _CharT , typename _Traits = std::char_traits<_CharT>>

std::__c_file* __gnu_cxx::stdio_filebuf< _CharT, _Traits >::file | ( |  | ) | `[inline]`

Returns:
  The underlying FILE*.

This function can be used to access the underlying "C" file pointer. Note that there is no way for the library to track what you do with the file, so be careful.

Definition at line 115 of file stdio_filebuf.h.

void std::basic_streambuf< _CharT , _Traits >::gbump | ( | int | __n | ) | `[inline, protected, inherited]`

Moving the read position.

Parameters:

  | n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 474 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

locale std::basic_streambuf< _CharT , _Traits >::getloc | ( |  | ) | const`[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 221 of file streambuf.

char_type* std::basic_streambuf< _CharT , _Traits >::gptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 461 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

virtual void std::basic_filebuf< _CharT , _Traits >::imbue | ( | const locale & |  | ) | `[protected, virtual, inherited]`

Changes translations.

Parameters:

  | loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, "Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained."

Note:
  Base class version does nothing.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

streamsize std::basic_streambuf< _CharT , _Traits >::in_avail | ( |  | ) | `[inline, inherited]`

Looking ahead into the stream.

Returns:
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 261 of file streambuf.

bool std::basic_filebuf< _CharT , _Traits >::is_open | ( |  | ) | const throw ()`[inline, inherited]`

Returns true if the external file is open.

Definition at line 222 of file fstream.

Referenced by __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf().

__filebuf_type* std::basic_filebuf< _CharT , _Traits >::open | ( | const std::string & | __s,
|  | ios_base::openmode | __mode |
| ) |  |  | `[inline, inherited]`

Opens an external file.

Parameters:

  | s | The name of the file.
  | mode | The open mode flags.

Returns:
  `this` on success, NULL on failure

Definition at line 275 of file fstream.

__filebuf_type* std::basic_filebuf< _CharT , _Traits >::open | ( | const char * | __s,
|  | ios_base::openmode | __mode |
| ) |  |  | `[inherited]`

Opens an external file.

Parameters:

  | s | The name of the file.
  | mode | The open mode flags.

Returns:
  `this` on success, NULL on failure

If a file is already open, this function immediately fails. Otherwise it tries to open the file named s using the flags given in mode.

Table 92, adapted here, gives the relation between openmode combinations and the equivalent fopen() flags. (NB: lines app, in|out|app, in|app, binary|app, binary|in|out|app, and binary|in|app per DR 596) +---------------------------------------------------------+ | ios_base Flag combination stdio equivalent | |binary in out trunc app | +---------------------------------------------------------+ | + "w" | | + + "a" | | + "a" | | + + "w" | | + "r" | | + + "r+" | | + + + "w+" | | + + + "a+" | | + + "a+" | +---------------------------------------------------------+ | + + "wb" | | + + + "ab" | | + + "ab" | | + + + "wb" | | + + "rb" | | + + + "r+b" | | + + + + "w+b" | | + + + + "a+b" | | + + + "a+b" | +---------------------------------------------------------+

virtual int_type std::basic_filebuf< _CharT , _Traits >::overflow | ( | int_type | = `_Traits::eof()` | ) | `[protected, virtual, inherited]`

Consumes data from the buffer; writes to the controlled sequence.

Parameters:

  | c | An additional character to consume.

Returns:
  eof() to indicate failure, something else (usually c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is "consumed", with "some effect" on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if c is not `eof()`.

For a formal definition of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

virtual int_type std::basic_filebuf< _CharT , _Traits >::pbackfail | ( | int_type | = `_Traits::eof()` | ) | `[protected, virtual, inherited]`

Tries to back up the input sequence.

Parameters:

  | c | The character to be inserted back into the sequence.

Returns:
  eof() on failure, "some other value" on success

Postcondition:
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

char_type* std::basic_streambuf< _CharT , _Traits >::pbase | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 505 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos().

void std::basic_streambuf< _CharT , _Traits >::pbump | ( | int | __n | ) | `[inline, protected, inherited]`

Moving the write position.

Parameters:

  | n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 521 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos().

char_type* std::basic_streambuf< _CharT , _Traits >::pptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 508 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos().

locale std::basic_streambuf< _CharT , _Traits >::pubimbue | ( | const locale & | __loc | ) | `[inline, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 204 of file streambuf.

pos_type std::basic_streambuf< _CharT , _Traits >::pubseekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out` |
| ) |  |  | `[inline, inherited]`

Current locale setting.

Definition at line 238 of file streambuf.

pos_type std::basic_streambuf< _CharT , _Traits >::pubseekpos | ( | pos_type | __sp,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out` |
| ) |  |  | `[inline, inherited]`

Current locale setting.

Definition at line 243 of file streambuf.

__streambuf_type* std::basic_streambuf< _CharT , _Traits >::pubsetbuf | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

Entry points for derived buffer functions.

The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged.

Definition at line 234 of file streambuf.

int std::basic_streambuf< _CharT , _Traits >::pubsync | ( |  | ) | `[inline, inherited]`

Current locale setting.

Definition at line 248 of file streambuf.

int_type std::basic_streambuf< _CharT , _Traits >::sbumpc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 293 of file streambuf.

virtual pos_type std::basic_filebuf< _CharT , _Traits >::seekoff | ( | off_type | ,
|  | ios_base::seekdir | ,
|  | ios_base::openmode | = `ios_base::in | ios_base::out` |
| ) |  |  | `[protected, virtual, inherited]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

virtual pos_type std::basic_filebuf< _CharT , _Traits >::seekpos | ( | pos_type | ,
|  | ios_base::openmode | = `ios_base::in | ios_base::out` |
| ) |  |  | `[protected, virtual, inherited]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

virtual __streambuf_type* std::basic_filebuf< _CharT , _Traits >::setbuf | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[protected, virtual, inherited]`

Manipulates the buffer.

Parameters:

  | s | Pointer to a buffer area.
  | n | Size of s.

Returns:
  `this`

If no file has been opened, and both s and n are zero, then the stream becomes unbuffered. Otherwise, `s` is used as a buffer; see http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt11ch25s02.html for more.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

void std::basic_streambuf< _CharT , _Traits >::setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend |
| ) |  |  | `[inline, protected, inherited]`

Setting the three read area pointers.

Parameters:

  | gbeg | A pointer.
  | gnext | A pointer.
  | gend | A pointer.

Postcondition:
  gbeg == `eback()`, gnext == `gptr()`, and gend == `egptr()`

Definition at line 485 of file streambuf.

void std::basic_streambuf< _CharT , _Traits >::setp | ( | char_type * | __pbeg,
|  | char_type * | __pend |
| ) |  |  | `[inline, protected, inherited]`

Setting the three write area pointers.

Parameters:

  | pbeg | A pointer.
  | pend | A pointer.

Postcondition:
  pbeg == `pbase()`, pbeg == `pptr()`, and pend == `epptr()`

Definition at line 531 of file streambuf.

int_type std::basic_streambuf< _CharT , _Traits >::sgetc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 315 of file streambuf.

streamsize std::basic_streambuf< _CharT , _Traits >::sgetn | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

Entry point for xsgetn.

Parameters:

  | s | A buffer area.
  | n | A count.

Returns xsgetn(s,n). The effect is to fill s[0] through s[n-1] with characters from the input sequence, if possible.

Definition at line 334 of file streambuf.

virtual streamsize std::basic_filebuf< _CharT , _Traits >::showmanyc | ( |  | ) | `[protected, virtual, inherited]`

Investigating the data available.

Returns:
  An estimate of the number of characters available in the input sequence, or -1.

"If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail." [27.5.2.4.3]/1

Note:
  Base class version does nothing, returns zero.

  The standard adds that "the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return "immediately".

  The standard adds that "the morphemes of `showmanyc` are "es-how-many-see", not "show-manic".

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

int_type std::basic_streambuf< _CharT , _Traits >::snextc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 275 of file streambuf.

int_type std::basic_streambuf< _CharT , _Traits >::sputbackc | ( | char_type | __c | ) | `[inline, inherited]`

Pushing characters back into the input stream.

Parameters:

  | c | The character to push back.

Returns:
  The previous character, if possible.

Similar to sungetc(), but c is pushed onto the stream instead of "the previous character". If successful, the next character fetched from the input stream will be c.

Definition at line 348 of file streambuf.

int_type std::basic_streambuf< _CharT , _Traits >::sputc | ( | char_type | __c | ) | `[inline, inherited]`

Entry point for all single-character output functions.

Parameters:

  | c | A character to output.

Returns:
  c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores c in that position, increments the position, and returns `traits::to_int_type(c)`. If a write position is not available, returns `overflow(c)`.

Definition at line 400 of file streambuf.

streamsize std::basic_streambuf< _CharT , _Traits >::sputn | ( | const char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

Entry point for all single-character output functions.

Parameters:

  | s | A buffer read area.
  | n | A count.

One of two public output functions.

Returns xsputn(s,n). The effect is to write s[0] through s[n-1] to the output sequence, if possible.

Definition at line 426 of file streambuf.

void std::basic_streambuf< _CharT , _Traits >::stossc | ( |  | ) | `[inline, inherited]`

Tosses a character.

Advances the read pointer, ignoring the character that would have been read.

See http://gcc.gnu.org/ml/libstdc++/2002-05/msg00168.html

Definition at line 758 of file streambuf.

int_type std::basic_streambuf< _CharT , _Traits >::sungetc | ( |  | ) | `[inline, inherited]`

Moving backwards in the input stream.

Returns:
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to "unget" the last character "gotten".

Definition at line 373 of file streambuf.

virtual int std::basic_filebuf< _CharT , _Traits >::sync | ( | void |  | ) | `[protected, virtual, inherited]`

Synchronizes the buffer arrays with the controlled sequences.

Returns:
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of "failure".

Note:
  Base class version does nothing, returns zero.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

virtual int_type std::basic_streambuf< _CharT , _Traits >::uflow | ( |  | ) | `[inline, protected, virtual, inherited]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Reimplemented in __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >.

Definition at line 676 of file streambuf.

virtual int_type std::basic_filebuf< _CharT , _Traits >::underflow | ( |  | ) | `[protected, virtual, inherited]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is "refilled". In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definition of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt11ch25.html

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

virtual streamsize std::basic_filebuf< _CharT , _Traits >::xsgetn | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[protected, virtual, inherited]`

Multiple character extraction.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to assign.

Returns:
  The number of characters assigned.

Fills s[0] through s[n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

virtual streamsize std::basic_filebuf< _CharT , _Traits >::xsputn | ( | const char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[protected, virtual, inherited]`

Multiple character insertion.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to write.

Returns:
  The number of characters written.

Writes s[0] through s[n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

## Member Data Documentation

char_type* std::basic_filebuf< _CharT , _Traits >::_M_buf `[protected, inherited]`

Pointer to the beginning of internal buffer.

Definition at line 109 of file fstream.

locale std::basic_streambuf< _CharT , _Traits >::_M_buf_locale `[protected, inherited]`

Current locale setting.

Definition at line 187 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::basic_filebuf().

size_t std::basic_filebuf< _CharT , _Traits >::_M_buf_size `[protected, inherited]`

Actual size of internal buffer. This number is equal to the size of the put area + 1 position, reserved for the overflow char of a full area.

Definition at line 116 of file fstream.

Referenced by __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf().

char* std::basic_filebuf< _CharT , _Traits >::_M_ext_buf `[protected, inherited]`

Buffer for external characters. Used for input when codecvt::always_noconv() == false. When valid, this corresponds to eback().

Definition at line 151 of file fstream.

streamsize std::basic_filebuf< _CharT , _Traits >::_M_ext_buf_size `[protected, inherited]`

Size of buffer held by _M_ext_buf.

Definition at line 156 of file fstream.

const char* std::basic_filebuf< _CharT , _Traits >::_M_ext_next `[protected, inherited]`

Pointers into the buffer held by _M_ext_buf that delimit a subsequence of bytes that have been read but not yet converted. When valid, _M_ext_next corresponds to egptr().

Definition at line 163 of file fstream.

char_type* std::basic_streambuf< _CharT , _Traits >::_M_in_beg `[protected, inherited]`

This is based on _IO_FILE, just reordered to be more consistent, and is intended to be the most minimal abstraction for an internal buffer.

- get == input == read
- put == output == write

Definition at line 179 of file streambuf.

char_type* std::basic_streambuf< _CharT , _Traits >::_M_in_cur `[protected, inherited]`

Current locale setting.

Definition at line 180 of file streambuf.

char_type* std::basic_streambuf< _CharT , _Traits >::_M_in_end `[protected, inherited]`

Current locale setting.

Definition at line 181 of file streambuf.

ios_base::openmode std::basic_filebuf< _CharT , _Traits >::_M_mode `[protected, inherited]`

Place to stash in || out || in | out settings for current filebuf.

Definition at line 94 of file fstream.

Referenced by __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf().

char_type* std::basic_streambuf< _CharT , _Traits >::_M_out_beg `[protected, inherited]`

Current locale setting.

Definition at line 182 of file streambuf.

char_type* std::basic_streambuf< _CharT , _Traits >::_M_out_cur `[protected, inherited]`

Current locale setting.

Definition at line 183 of file streambuf.

char_type* std::basic_streambuf< _CharT , _Traits >::_M_out_end `[protected, inherited]`

Current locale setting.

Definition at line 184 of file streambuf.

char_type std::basic_filebuf< _CharT , _Traits >::_M_pback `[protected, inherited]`

Necessary bits for putback buffer management.

Note:
  pbacks of over one character are not currently supported.

Definition at line 137 of file fstream.

char_type* std::basic_filebuf< _CharT , _Traits >::_M_pback_cur_save `[protected, inherited]`

Necessary bits for putback buffer management.

Note:
  pbacks of over one character are not currently supported.

Definition at line 138 of file fstream.

char_type* std::basic_filebuf< _CharT , _Traits >::_M_pback_end_save `[protected, inherited]`

Necessary bits for putback buffer management.

Note:
  pbacks of over one character are not currently supported.

Definition at line 139 of file fstream.

bool std::basic_filebuf< _CharT , _Traits >::_M_pback_init `[protected, inherited]`

Necessary bits for putback buffer management.

Note:
  pbacks of over one character are not currently supported.

Definition at line 140 of file fstream.

bool std::basic_filebuf< _CharT , _Traits >::_M_reading `[protected, inherited]`

_M_reading == false && _M_writing == false for 'uncommitted' mode; _M_reading == true for 'read' mode; _M_writing == true for 'write' mode;

NB: _M_reading == true && _M_writing == true is unused.

Definition at line 128 of file fstream.

Referenced by __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf().

The documentation for this class was generated from the following file:

- stdio_filebuf.h